// 定义公共url
const API_BASE_URL = "https://duoduoenv.sagacloud.cn";
// 计算每次请求的次数
var requestTimes = 0;
const request = function request(url, method, data = {}) {
  wx.showLoading({
    title: "加载中..."
  })
  var _url = API_BASE_URL + url;
  data = Object.assign(data, {
    openid: wx.getStorageSync('openId')
  })
  if (method === "GET") {
    
    data = Object.assign(data, {
      pubname: "sagacare"
    })
    console.log(data,"18")
  } else {
    _url = _url + `?pubname=sagacare&openid=${wx.getStorageSync('openId')}`
    if (data.flag) {
      _url = _url + `&flag=${data.flag}`
    }
  }
  return new Promise(function (resolve, reject) {
    requestTimes++
    wx.request({
      url: _url,
      method: method,
      data: data,
      header: {
        'content-type': 'application/json'
      },
      success: function success(request) {
        resolve(request.data);
      },
      fail: function fail(error) {
        wx.hideLoading();
        wx.showModal({
          title: '网络错误',
          content: '网络出错，请刷新重试',
          showCancel: false
        })
        reject(error);
      },
      complete: function complete() {
        // 加载完成
        requestTimes--
        if (requestTimes === 0) {
          wx.hideLoading()
        }
      }
    });
  });
};
module.exports = {
  request: request
}